
/* Canon PowerShot 350 Picture Downloader

   Copyright (C) 1999 H.Haanp
   CRC routine and picture file naming (C) 1999 J.A.Bezemer

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

void do_download(char *sector, int filelen);

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <assert.h>
#include <sys/types.h>
#include <time.h>
#include <sys/time.h>
#include <termios.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <signal.h>  
//#include "iostream"
//#include "fstream"
#include <Errors.h>
#include <AppFileInfo.h>
#include <image.h>
#include <Path.h>
#include <FindDirectory.h>
#include <cstdio>
#include <device/SerialPort.h>
unsigned char raw_data[300];
unsigned char tmp[300];
unsigned char dirent[30000];
unsigned char dirent2[30000];
unsigned char bigbuf[30000];
BSerialPort serial;
unsigned char count;
char *serport; 
char *port="serial1";
//FILE *camera;
char *help = "\n 1-st argument must be port number in range 1-4\n2-nd argument (speed) must be 0 (for 9600), 1 (for 19200),  2 (for 38400), 3 (for 57600), 4 (for 115200) bps\n" ;
 struct cameraspeed {
  	char* speedstr; 
  	data_rate datarate;} speed[5] =    {{"\0x42\0x00",B_9600_BPS}, {"\0x42\0x01",B_19200_BPS}, {"\0x42\0x02",B_38400_BPS}, {"\0x42\0x03",B_57600_BPS}, {"\0x42\0x04",B_115200_BPS} };
 
int camera;
int readpack(unsigned char * buf, int cnt);
int readpack(unsigned char * buf, int cnt)
{
int i, j;

for (i=0; i<cnt; )
	{
	j=0;
	if((j=serial.WaitForInput())==0 ) {printf("\nTimeout expired - maybe camera isn't connected to %s!!!", serport); return 0;};
	if (i+j >= cnt) 
		{
		serial.Read(&(buf[i]), cnt - i);
		i = cnt;
		}
	else
		{
		serial.Read(&(buf[i]), j);
		i +=j;
		}
	}
return i;
//return serial.Read((char *)buf, cnt);
}
int set_speed(int);

int crc(char *data)
{
  long datalen = 296;		/* number of data bytes. Always 296. */

  char bits[] =
  {1, 2, 4, 8, 16, 32, 64, 128};
  long chksum = 0;
  long i, j;
  int inputbit, lastbit, xorbit;

  /* calculate checksum */
  for (i = 0; i < datalen; i++)
    for (j = 0; j <= 7; j++)
      {
	lastbit = chksum & 0x0001;	/* remember if last bit was 1 */
	chksum >>= 1;		/* shift 1 place */
	inputbit = data[i] & bits[j] ? 1 : 0;	/* the In bit */
	xorbit = inputbit ^ lastbit;	/* output of upper XOR gate */
	if (xorbit)		/* XOR if needed */
	  chksum ^= 0x8408;
      }

  /* display checksum */
  return chksum;
}

void send(char *packet, int len) {
  int i;
  int chksum;

  for (i=0; i<300; i++)
    raw_data[i]=0;

  for (i=0; i<len; i++)
    raw_data[i+1]=packet[i];

  chksum=crc((char *)raw_data+1);

  raw_data[0]=0xC0;
  raw_data[299]=0xC1;
  raw_data[297]=chksum % 256;
  raw_data[298]=chksum / 256;

  serial.Write( raw_data, 300);
 // fwrite(raw_data, 1, 300, stderr);
}

int getdir(char *buffer) {
  int len=0;
  int plen=0;
  
  readpack( raw_data, 300); /* get response packet */
  
  fwrite(raw_data, 1, 300, stdout);fflush(stdout);
  //fflush(stdout);
  plen=raw_data[3]+256*(raw_data[4]&0x7F);
  memcpy(buffer, raw_data+25, plen-20);
  len+=plen-20;

  readpack( raw_data, 300);//
  fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  //fflush(stdout);
 fprintf(stdout, "\nlen = %d packet= %d", len, (int)raw_data[0]);
    fflush(stdout);
  while(raw_data[2]!=3 /*raw_data[4] != 0 && raw_data[5] != 0*/) {
  
     //readpack( raw_data, 300);//fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
     plen=raw_data[3]+256*(raw_data[4]&0x7F);
    memcpy(buffer+len, raw_data+5, plen);
    len+=plen;
    fprintf(stdout, "\nlen = %d packet= %d", len, (int)raw_data[0]);
    fflush(stdout);
    readpack( raw_data, 300);//
    fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */

  }

  return len;
}

void send_ack() {
  static char ack_str[] = "!\003\004\000\001\000\000\000";

  ack_str[0]=count;

  send(ack_str, 8);
}


int ping() {
  send("\000\020\014\000\000\000\000\000\061\000\001\140\014\000\000\000",16);
	
  if(readpack( raw_data, 300)  ==0) return 0; //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  
  assert(raw_data[9]==9); /* is it a ping reply? */

  if(readpack( raw_data, 300)  ==0) return 0; //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */

  assert(raw_data[2]==3); /* is it an EOT packet? */

  count = raw_data[1];
fprintf(stdout, "\nPing count = %d", count); fflush(stdout);
  send_ack();

  return 1;
}

void send_unknown1() {
  //static char unk1_str[] = "\000\020\020\000\000\000\000\000\036\000\001\140\020\000\000\007\000\000\000";
  static char unk1_str[] = "\000\020\020\000\000\000\000\000\036\000\001\140\020\000\000\000!\000\000\000";
  unk1_str[16]=++count;

  send(unk1_str, 20);
}

void send_getdisk() {
  static char getdisk_str[] = "\000\020\024\000\000\000\000\000\030\000\001\140\024\000\000\000!\000\000\000\036\000\000\000";

  getdisk_str[16]=++count;

  send(getdisk_str, 24);
}

void send_usedisk() {
  static char usedisk_str[] = "\000\020\041\000\000\000\000\000\024\000\041\240\041\000\000\000!\000\000\000REMOVABLE_1:\000\000\000\000\000";

  usedisk_str[16]=++count;

  send(usedisk_str, 37);
}

void send_namefordir(char *dir) {
  static char namefordir_str[] = "\000\020\042\000\000\000\000\000\002\000\041\240\042\000\000\000!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\00\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000";

  namefordir_str[16]=++count;
  sprintf(namefordir_str+20, "%s", dir);
  namefordir_str[2]=namefordir_str[12]=strlen(dir)+17;
  
  send(namefordir_str, strlen(dir)+21);
}

void send_nameforfile(char *file) {
  static char nameforfile_str[] = "\000\020x\000\000\000\000\000\001\000\101\240x\000\000\000!\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\00\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000";

  nameforfile_str[16]=++count;
  sprintf(nameforfile_str+24, "%s", file);
  nameforfile_str[2]=nameforfile_str[12]=strlen(file)+21;
  
  send(nameforfile_str, strlen(file)+25);
}

void send_prepdirdl(char *sector) {
  static char pddl_str[] = "\000\020\024\000\000\000\000\000\004\000\001\140\024\000\000\000!\000\000\000xxxx";

  pddl_str[16]=++count;

  pddl_str[20]=sector[0];
  pddl_str[21]=sector[1];
  pddl_str[22]=sector[2];
  pddl_str[23]=sector[3];

  send(pddl_str, 24);
}

void send_prepfdl(char *sector) {
  static char pfdl_str[] = "\000\020\024\000\000\000\000\000\027\000\001\140\024\000\000\000!\000\000\000xxxx";

  pfdl_str[16]=++count;

  pfdl_str[20]=sector[0];
  pfdl_str[21]=sector[1];
  pfdl_str[22]=sector[2];
  pfdl_str[23]=sector[3];

  send(pfdl_str, 24);
}

void send_dirdl(char *sector) {
  static char ddl_str[] = "\000\020\034\000\000\000\000\000\052\000\201\240\034\000\000\000!\000\000\000xxxx\350\003\000\000\000\000\000\000";

  ddl_str[16]=++count;

  ddl_str[20]=sector[0];
  ddl_str[21]=sector[1];
  ddl_str[22]=sector[2];
  ddl_str[23]=sector[3];

  send(ddl_str, 32);
}

void send_forgetd(char *sector) {
  static char forgetd_str[] = "\000\020\024\000\000\000\000\000\003\000\001\140\024\000\000\000!\000\000\000xxxx";

  forgetd_str[16]=++count;

  forgetd_str[20]=sector[0];
  forgetd_str[21]=sector[1];
  forgetd_str[22]=sector[2];
  forgetd_str[23]=sector[3];
  send(forgetd_str, 24);
}

void send_forgetf(char *sector) {
  static char forgetf_str[] = "\000\020\024\000\000\000\000\000\021\000\001\140\024\000\000\007\000\000\000xxxx";

  forgetf_str[16]=++count;

  forgetf_str[20]=sector[0];
  forgetf_str[21]=sector[1];
  forgetf_str[22]=sector[2];
  forgetf_str[23]=sector[3];
  send(forgetf_str, 24);
}

int set_speed(int  i)
{
int ans;
char buf[600];
fprintf(stdout, "\nTrying speed %d", i); fflush(stdout);
serial.Write("\0x00", 1);
//if(readpack((unsigned char *) buf,1) ==0)  {printf("Break timeout"); exit(-1);};
sleep(1);
//fprintf(stdout, "\nSetting computer speed to 9600"); fflush(stdout);
//serial.SetDataRate(B_9600_BPS);
//fprintf(stdout, "\nWriting camera speed string"); fflush(stdout);
//while(serial.DataRate() != B_9600_BPS);
serial.Write(speed[i].speedstr, 2);
//"\x0E\xC0\x00\x03\x08\x02\x01\x10\x00\x00\x00\x00\x13\x1f\xC1"
serial.SetDataRate(speed[i].datarate);
serial.Write("\x53", 1);
//serial.SetTimeout(5000000);
fprintf(stdout, "\nPinging speed "); fflush(stdout);
//serial.SetDataRate(B_9600_BPS);
sleep(1);
return ping();
}

  	
main(int argc, char** argv) {
  char sector[4];
  char dirname[80];
  char filename[80];
  int portnum;
  char *speedstr;
  unsigned char my_data[1024];
  int dir, file, filelen, i, j, oldcount;
  //struct cameraspeed speed[5] =    {{"\0x42\0x00",B_9600_BPS}, {"\0x42\0x01",B_19200_BPS}, {"\0x42\0x02",B_38400_BPS}, {"\0x42\0x03",B_57600_BPS}, {"\0x42\0x04",B_115200_BPS} };
serport = "serial1";
  if(argc >2)
  	if((argv[2])[0] >'0' && (argv[2])[0]  < '5' )
	 	switch((argv[2])[0])
	 	{
	 	case '4': serport = "serial4";  break;
	 	case '3': serport = "serial3"; break;
	 	case '2': serport = "serial2"; break;
	 	case '1': 
	 	default: serport = "serial1";  break;
	 	}
	 else  
	 	{printf(help);    serial.Write("\0x00\0x01\0x00\0x00",4); exit(-1);}	
	 printf(serport);
  	
  if(! serial.Open(serport))
	{
	printf("\ncannot open serial1");
	   serial.Write("\0x00\0x01\0x00\0x00",4);
	exit(-1);
	}
serial.SetDataBits(B_DATA_BITS_8);
serial.SetStopBits(B_STOP_BITS_1);
serial.SetParityMode(B_NO_PARITY);
serial.SetFlowControl(B_HARDWARE_CONTROL);
serial.SetDataRate(B_9600_BPS);
serial.ClearInput();  
serial.ClearOutput();
serial.SetTimeout(5000000);
serial.SetBlocking(true);
serial.Write("\0SUUUU",6);
if((i = readpack(my_data, 300))==0) {
		printf("\nSorry - cannot connect!");
		   serial.Write("\0x00\0x01\0x00\0x00",4);
		exit(-1);
		};
fprintf(stdout, "\nRead BSerial  n=%d\n", i);
fwrite(my_data, 1, i, stdout);fflush(stdout); /* get response packet */
 fflush(stdout);
if((i = readpack(my_data, 300))==0) {
		printf("\nSorry - cannot connect!");
		   serial.Write("\0x00\0x01\0x00\0x00",4);
		exit(-1);
		};
 send_ack();

sleep(1);

oldcount = count;
j = 4;
if (argc >1)
	if(argv[1][0]  >= '0' && argv[1][0] < '5')
		j = (int)((argv[1])[0] - '0'); 

for(i=j; i >=0; )
{
if(set_speed(i) ==0)  --i;
else break;
sleep(1);
}




count = oldcount;


  fflush(stdout);

//serial.ClearInput();  
//serial.ClearOutput();
  //ping();
  
printf("\nSendUnknown");
  fflush(stdout);
  send_unknown1();
  
   i = readpack( raw_data, 300); 
   fwrite(my_data, 1, i, stdout);fflush(stdout); /* get response packet */
   fprintf(stdout, "\nUnknown  n=%d\n", i);
  fflush(stdout);
  
  i += readpack( raw_data, 300); fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  fprintf(stdout, "\nUnknown  n=%d\n", i);
  fflush(stdout);
  send_ack();
  
  
printf("\nSendGetdisk");
  fflush(stdout);
  send_getdisk();
  
  i = readpack( raw_data, 300);//
  fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
   fprintf(stdout, "\nGetDisk  n=%d\n", i);
   
  i += readpack( raw_data, 300);//fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  fprintf(stdout, "\nGetDisk  n=%d\n", i);
  fflush(stdout);
  send_ack();
  
  
  printf("\nSendUsedisk");
  fflush(stdout);
    send_usedisk();
    
  i = readpack( raw_data, 300);//
  fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  fprintf(stdout, "\nUsedisk  n=%d\n", i);
  
  i += readpack( raw_data, 300);//fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  fprintf(stdout, "\nUsedisk  n=%d\n", i);
  fflush(stdout);
  send_ack();


  send_namefordir("REMOVABLE_1:\\DC97");
  
 fprintf(stdout, "\nSendREMOVABLE_1:\\DC97");
  fflush(stdout);
  i = readpack( raw_data, 300);//
  fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  sector[0]=raw_data[25];
  sector[1]=raw_data[26];
  sector[2]=raw_data[27];
  sector[3]=raw_data[28];
    fprintf(stdout, "\nsectors = %d %d %d %d",sector[0], sector[1], sector[2], sector[3]);
    fprintf(stdout, "\nRemovable  n=%d\n", i); 
  fflush(stdout);
  
  i += readpack( raw_data, 300);//
  fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
   fprintf(stdout, "\nRemovable  n=%d\n", i);
  fflush(stdout);
  send_ack();
    
    
fprintf(stdout, "\nSendprepdir");
  fflush(stdout);

  send_prepdirdl(sector);
  
  i = readpack( raw_data, 300);//
  fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  //fwrite(raw_data, 1, 300, stdout);fflush(stdout);
  
  fprintf(stdout, "\nPrepdir  n=%d\n", i);
  i += readpack( raw_data, 300);//
  fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  fprintf(stdout, "\nPrepdir  n=%d\n", i);
  send_ack();
  
  
fprintf(stdout, "\nSenddirdl");
  fflush(stdout);
  send_dirdl(sector);
  //send_ack(); //fyy
  
  fprintf(stdout, "\nGetting dir");
  fflush(stdout);
  
  // i = readpack(my_data, serial.WaitForInput());
   fprintf(stdout, "\nDirData  n=%d\n", i);
  //  fwrite(my_data, 1, i, stdout);
  getdir((char *)dirent);
  fprintf(stdout, "\nGot dir");
  fflush(stdout);
  send_ack();
   

fprintf(stdout, "\nSendforgetd");
  fflush(stdout);
  send_forgetd(sector);
  
  i = readpack( raw_data, 300);//
  fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  fprintf(stdout, "\nForget n=%d", i);
  
  i += readpack( raw_data, 300);//fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
  fprintf(stdout, "\nForget n=%d", i);
  fflush(stdout);
  send_ack();

  
fprintf(stdout, "\ndirent = %d", dirent[0] - 2);	

  for(dir=2; dir<dirent[0]; dir++) {
    if(dirent[21*dir+11]==229 )
      continue;
    snprintf(dirname, 31, "REMOVABLE_1:\\DC97\\%s",dirent+21*dir+11);
    fprintf(stdout, "\n dir %s %d", dirname, dir);
    if(strstr(dirname, "CTG_") ==NULL) continue;
    fprintf(stdout, "\nSend name for dir %s", dirname);
  fflush(stdout);
  
    send_namefordir(dirname);
    
    i = readpack( raw_data, 300); //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
      fprintf(stdout, "\nnamefordir n=%d", i);
  fflush(stdout);
    sector[0]=raw_data[25];
    sector[1]=raw_data[26];
    sector[2]=raw_data[27];
    sector[3]=raw_data[28];
    
     fprintf(stdout, "\nsectors2 = %d %d %d %d",sector[0], sector[1], sector[2], sector[3]);
   
    i += readpack( raw_data, 300); //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
    fprintf(stdout, "\nnamefordir n=%d", i);
  fflush(stdout);
    send_ack();
	
	
    send_prepdirdl(sector);
    
    i = readpack( raw_data, 300); //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
        fprintf(stdout, "\nprepdirdl n=%d", i);
  fflush(stdout);
    
    i += readpack( raw_data, 300);  //(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
           fprintf(stdout, "\nnprepdirdl n=%d", i);
  fflush(stdout);
    send_ack();
    
    

    send_dirdl(sector);
    
    getdir((char *)dirent2);
    send_ack();


    send_forgetd(sector);
    
    i = readpack( raw_data, 300);  //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
           fprintf(stdout, "\nforgetdir n=%d", i);   fflush(stdout);
    
   i +=  readpack( raw_data, 300); //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
     fprintf(stdout, "\n forgetdir n=%d", i);   fflush(stdout);
    
    send_ack();
    
fprintf(stdout, "\n%d files to dl", dirent2[0]);
fflush(stdout);

    for(file=2; file<dirent2[0]; file++) {
      if(dirent2[21*file+11]==229)
	continue;
      strcpy(filename, dirname);
      snprintf(filename+strlen(filename), 14, "\\%s", dirent2+21*file+11);
      
fprintf(stdout, "\n filename %s", filename);
fflush(stdout);	 
      if(strstr(filename, "AUT") == NULL) continue;
	
      send_nameforfile(filename);
      
      i = readpack( raw_data, 300); //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
       fprintf(stdout, "\nnameforfile %s n=%d\n", filename, i);
  fflush(stdout);
      sector[0]=raw_data[25];
      sector[1]=raw_data[26];
      sector[2]=raw_data[27];
      sector[3]=raw_data[28];
      
       i += readpack( raw_data, 300); //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
       fprintf(stdout, "\nnameforfile %s n=%d\n", filename, i);
         fflush(stdout);
      send_ack();
      
      
      send_prepfdl(sector);
      
      i = readpack( raw_data, 300);fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
       fprintf(stdout, "\nprepfldl n=%d\n", i);
  fflush(stdout);
      filelen=
	raw_data[25]
	+256*raw_data[26]
	+65536*raw_data[27]
	+16777216*raw_data[28];

      i += readpack( raw_data, 300);fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
            fprintf(stdout, "\nprepfldl n=%d\n", i);
  fflush(stdout);
      send_ack();
      

      if (filelen>0)
	do_download(sector,filelen);
      
      send_forgetf(sector);
      
      i = readpack( raw_data, 300);fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
            fprintf(stdout, "\nforgetsect n=%d\n", i);
  fflush(stdout);
      
       i += readpack( raw_data, 300);fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
               fprintf(stdout, "\nforgetsect n=%d\n", i);
  fflush(stdout);
      send_ack();

    }
  }
   serial.Write("\0x00\0x01\0x00\0x00",4);
}

void do_download(char *sector, int filelen) {
  static char fdl_str[]="\000\020\030\000\000\000\000\000\022\000\001\140\030\000\000\000!\000\000\000xxxxyyyy";
  time_t time;
  struct tm *temptm;
  char timestring[200];
  char tempstring[300];
  char newname[300];
  int newnamecounter, i;
  struct stat statbuf2;
  FILE *jpgfile;

  fdl_str[16]=++count;

  fdl_str[20]=sector[0];
  fdl_str[21]=sector[1];
  fdl_str[22]=sector[2];
  fdl_str[23]=sector[3];

  if (filelen>=0x245C) {
    fdl_str[24]=0x5C;
    fdl_str[25]=0x24;
    fdl_str[26]=0x00;
    fdl_str[27]=0x00;
  } else {
    fdl_str[24]=filelen & 0xFF;
    fdl_str[25]=(filelen >> 8) & 0xFF;
    fdl_str[26]=(filelen >>16) & 0xFF;
    fdl_str[27]=(filelen >>24) & 0xFF;
  }

  send(fdl_str, 28);
	
  i= readpack( raw_data, 300); //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
           fprintf(stdout, "\nreadingfiledate n=%d\n", i);
  fflush(stdout);

  time=    (((time_t) raw_data[91])       )
    | (((time_t) raw_data[92]) << 8  )
    | (((time_t) raw_data[93]) << 16 )
    | (((time_t) raw_data[94]) << 24 );

  temptm=gmtime(&time);

  strftime(timestring, 200, "%Y%m%d-%H%M%S", temptm);

  if (raw_data[14] < 20)
    /* thumbnail */
    snprintf(tempstring, 200, "thm_%s", timestring);
  else
    /* other jpg */
    snprintf(tempstring, 200, "aut_%s", timestring);
  
  snprintf(newname, 200, "%s.jpg", tempstring);
  newnamecounter=1;
  
  /* check if file exists. Will hang if all names are used... */
  while (stat(newname, &statbuf2)==0) {
    newnamecounter++;
    snprintf(newname, 200, "%s-%d.jpg", tempstring, newnamecounter);
  }

  jpgfile=fopen(newname, "w");
    fprintf(stdout, "\nfile =%s", newname);
  fflush(stdout);

  fwrite(raw_data+41, 1,
	 raw_data[3]+256*(raw_data[4]&0x7F)-36, jpgfile);

  for(;;) {

    i = readpack( raw_data, 300);//fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
     //fwrite(".",1,1,stdout);
  //fflush(stdout);
    while(raw_data[2]!=3) { /* until we get an EOT */
      fwrite(raw_data+5, 1,
	     raw_data[3]+256*(raw_data[4]&0x7F), jpgfile);
	
      readpack( raw_data, 300) ; //fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
        fwrite(".",1,1,stdout);
  fflush(stdout);
    }
    send_ack();
    filelen-=0x245C;
    if(filelen<=0)
      break;
    if (filelen<0x245C) {
      fdl_str[24]=filelen & 0xFF;
      fdl_str[25]=(filelen >> 8) & 0xFF;
      fdl_str[26]=(filelen >>16) & 0xFF;
      fdl_str[27]=(filelen >>24) & 0xFF;
    }
    send(fdl_str, 28);
    
    readpack( raw_data, 300);//fwrite(raw_data, 1, 300, stdout);fflush(stdout); /* get response packet */
    fwrite(raw_data+41, 1,
	   raw_data[3]+256*(raw_data[4]&0x7F)-36, jpgfile);
  }
  fclose(jpgfile);
}

